variables:

  KUBE_INGRESS_BASE_DOMAIN: "agent.gronk.eu"
  KUBE_CTL_CONTEXT_NAME: ""
  DEPLOY_MODE: "pull"
 
  CODE_INTELLIGENCE_DISABLED: "true"
  CODE_QUALITY_DISABLED: "true"
  SAST_DISABLED: "true"
  CONTAINER_SCANNING_DISABLED: "true"
  DAST_DISABLED: "true"
  DEPENDENCY_SCANNING_DISABLED: "true"
  LICENSE_MANAGEMENT_DISABLED: "true"
  BROWSER_PERFORMANCE_DISABLED: "true"
  #STAGING_ENABLED: "true"
  #INCREMENTAL_ROLLOUT_MODE: "manual"
  
  PERFORMANCE_DISABLED: "true"
  POSTGRES_ENABLED: "false"
  PRODUCTION_REPLICAS: 4
  
  #CI_DEBUG_TRACE: "true"
  #REVIEW_DISABLED: "true"
  #BUILD_DISABLED: "true"
  SECRET_DETECTION_DISABLED: "true"
  TEST_DISABLED: "true"
  
    
include:
  - template: Auto-DevOps.gitlab-ci.yml


inspect:
  stage: performance
  variables:
    GIT_STRATEGY: none
  image:
     name: bitnami/kubectl:latest
     entrypoint: [""]
  script:
    - ls
    - cat $KUBECONFIG
    - cp $KUBECONFIG test.yaml
    - kubectl config use $(kubectl config view -o=jsonpath='{'.contexts[0].name'}')
    - kubectl get deployment,pod,service,ingress,configmap,secret -n $CI_PROJECT_NAME-$CI_PROJECT_ID-$(cat environment_name.txt)
  artifacts:
    paths:
    - test.yaml
  rules:
  - if: $CI_MERGE_REQUEST_IID
    when: manual
  - if: $CI_COMMIT_TAG
    when: manual
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    when: manual

production:
  image:
    name: alpine
    entrypoint: [""]
  dependencies: []
  extends: 
  variables:
    KUSTOMIZE_VERSION: v4.1.2
  stage: production
  script:
    - echo $CI_ENVIRONMENT_SLUG >environment_name.txt
    - apk add curl git 
    - curl -LO "https://github.com/kubernetes-sigs/kustomize/releases/download/kustomize/${KUSTOMIZE_VERSION}/kustomize_${KUSTOMIZE_VERSION}_linux_amd64.tar.gz"
    - tar -xvf kustomize_${KUSTOMIZE_VERSION}_linux_amd64.tar.gz
    - mv kustomize /usr/bin/kustomize
    - cd .gitlab/kustomize
    - git config --global credential.helper store
    - git clone "https://$GITLAB_USER:$GITLAB_TOKEN@${CI_SERVER_HOST}/gronk/manifests.git" manifests
    - git config --global user.email "ralf@gronkowski.de"
    - git config --global user.name "gronk"
    - kustomize edit set image someimage=$CI_REGISTRY_IMAGE/$CI_COMMIT_BRANCH:$CI_COMMIT_SHA
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PROJECT_ID=$CI_PROJECT_ID
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PROJECT_PATH=$CI_PROJECT_PATH
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PROJECT_URL=$CI_PROJECT_URL
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_MERGE_REQUEST_IID=$CI_MERGE_REQUEST_IID
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_MERGE_REQUEST_ID=$CI_MERGE_REQUEST_ID 
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PIPELINE_IID=$CI_PIPELINE_IID
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_COMMIT_TITLE="$CI_COMMIT_TITLE"
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PROJECT_PATH_SLUG=$CI_PROJECT_PATH_SLUG
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PIPELINE_URL=$CI_PIPELINE_URL
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_MERGE_REQUEST_TITLE="$CI_MERGE_REQUEST_TITLE"
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_MERGE_REQUEST_PROJECT_URL=$CI_MERGE_REQUEST_PROJECT_URL
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_ENVIRONMENT_NAME=$CI_ENVIRONMENT_NAME
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_COMMIT_SHA=$CI_COMMIT_SHA
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_SERVER_URL=$CI_SERVER_URL
    - kustomize edit add label app:$CI_PROJECT_NAME environment:$CI_ENVIRONMENT_SLUG
    - kustomize edit set namespace $CI_PROJECT_NAME-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG
    - kustomize edit set replicas production=$PRODUCTION_REPLICAS
    - sed -i 's/hostname/'"$CI_PROJECT_PATH_SLUG.$KUBE_INGRESS_BASE_DOMAIN"'/g' ingress-patch.json
    - kustomize build . > manifests/$CI_PROJECT_NAME-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.yaml
    - cp manifests/$CI_PROJECT_NAME-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.yaml ../../manifest.yaml
    - cd manifests
    - git add $CI_PROJECT_NAME-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.yaml
    - |-
      CHANGES=$(git status --porcelain | wc -l)
      if [ "$CHANGES" -gt "0" ]; then
        git commit -m "${CI_COMMIT_TITLE}"
        git push -o ci.skip
      fi    

  environment:
    name: production
    url: http://$CI_PROJECT_PATH_SLUG.$KUBE_INGRESS_BASE_DOMAIN
  artifacts:
    paths:
    - manifest.yaml
    - environment_name.txt
    when: always
  rules:
  - if: "$CI_DEPLOY_FREEZE != null"
    when: never
  - if: "$STAGING_ENABLED"
    when: never
  - if: "$CANARY_ENABLED"
    when: never
  - if: "$INCREMENTAL_ROLLOUT_ENABLED"
    when: never
  - if: "$INCREMENTAL_ROLLOUT_MODE"
    when: never
  - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"

build:
  rules:
  - if: "$BUILD_DISABLED"
    when: never
  - if: $AUTO_DEVOPS_PLATFORM_TARGET == "EC2"
    when: never
  - if: $CI_MERGE_REQUEST_IID
  - if: $CI_COMMIT_TAG
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH


test:
  rules:
  - if: "$TEST_DISABLED"
    when: never
  - if: $CI_MERGE_REQUEST_IID
  - if: $CI_COMMIT_TAG
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

code_quality:
  rules:
  - if: "$CODE_QUALITY_DISABLED"
    when: never
  - if: $CI_MERGE_REQUEST_IID
  - if: $CI_COMMIT_TAG
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

code_intelligence_go:
  image: sourcegraph/lsif-go:v1.3.1
  rules:
  - if: "$CODE_INTELLIGENCE_DISABLED"
    when: never
#  - if: "$CI_COMMIT_BRANCH"
#    exists:
#    - "**/*.go"
  - if: $CI_MERGE_REQUEST_IID
    exists:
    - "**/*.go"
  - if: $CI_COMMIT_TAG
    exists:
    - "**/*.go"
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    exists:
    - "**/*.go"

".auto-deploy":
  image: registry.gitlab.com/gitlab-org/cluster-integration/auto-deploy-image:v1.0.7
  dependencies: []
review:
  image:
    name: alpine
    entrypoint: [""]
  dependencies: []
  variables:
    KUSTOMIZE_VERSION: v4.1.2
  script:
    - apk add curl git 
    - curl -LO "https://github.com/kubernetes-sigs/kustomize/releases/download/kustomize/${KUSTOMIZE_VERSION}/kustomize_${KUSTOMIZE_VERSION}_linux_amd64.tar.gz"
    - tar -xvf kustomize_${KUSTOMIZE_VERSION}_linux_amd64.tar.gz
    - mv kustomize /usr/bin/kustomize
    - cd .gitlab/kustomize
    - git config --global credential.helper store
    - git clone "https://$GITLAB_USER:$GITLAB_TOKEN@${CI_SERVER_HOST}/gronk/manifests.git" manifests
    - git config --global user.email "ralf@gronkowski.de"
    - git config --global user.name "gronk"
    - kustomize edit set image someimage=$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME:$CI_COMMIT_SHA
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PROJECT_ID=$CI_PROJECT_ID
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PROJECT_PATH=$CI_PROJECT_PATH
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PROJECT_URL=$CI_PROJECT_URL
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_MERGE_REQUEST_IID=$CI_MERGE_REQUEST_IID
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_MERGE_REQUEST_ID=$CI_MERGE_REQUEST_ID 
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PIPELINE_IID=$CI_PIPELINE_IID
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_COMMIT_TITLE="$CI_COMMIT_TITLE"
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PROJECT_PATH_SLUG=$CI_PROJECT_PATH_SLUG
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_PIPELINE_URL=$CI_PIPELINE_URL
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_MERGE_REQUEST_TITLE="$CI_MERGE_REQUEST_TITLE"
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_MERGE_REQUEST_PROJECT_URL=$CI_MERGE_REQUEST_PROJECT_URL
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_ENVIRONMENT_NAME=$CI_ENVIRONMENT_NAME
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_COMMIT_SHA=$CI_COMMIT_SHA
    - kustomize edit add configmap env-conf --disableNameSuffixHash --from-literal=CI_SERVER_URL=$CI_SERVER_URL
    - kustomize edit add label app:$CI_PROJECT_NAME environment:$CI_ENVIRONMENT_SLUG
    - kustomize edit set namespace $CI_PROJECT_NAME-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG
    - kustomize edit set replicas production=2
    - sed -i 's/hostname/'"$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.$KUBE_INGRESS_BASE_DOMAIN"'/g' ingress-patch.json
    - kustomize build . > manifests/$CI_PROJECT_NAME-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.yaml
    - cp manifests/$CI_PROJECT_NAME-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.yaml ../../manifest.yaml
    - cd manifests
    - git add $CI_PROJECT_NAME-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.yaml
    - |-
      CHANGES=$(git status --porcelain | wc -l)
      if [ "$CHANGES" -gt "0" ]; then
        git commit -m "${CI_COMMIT_TITLE}"
        git push -o ci.skip
      fi    
  artifacts:
    paths:
    - manifest.yaml
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.$KUBE_INGRESS_BASE_DOMAIN
    on_stop: stop_review
  rules:
  - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
    when: never
  - if: "$REVIEW_DISABLED"
    when: never
  - if: $CI_MERGE_REQUEST_IID
  - if: $CI_COMMIT_TAG

stop_review:
  image:
    name: alpine
    entrypoint: [""]
  dependencies: []
  script:
    - apk add git
    - cd .gitlab/kustomize
    - rm -Rf manifests | true
    - git config --global credential.helper store
    - git clone "https://$GITLAB_USER:$GITLAB_TOKEN@${CI_SERVER_HOST}/gronk/manifests.git" manifests
    - git config --global user.email "ralf@gronkowski.de"
    - git config --global user.name "gronk"
    - cd manifests
    - git rm $CI_PROJECT_NAME-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.yaml
    - |-
      CHANGES=$(git status --porcelain | wc -l)
      if [ "$CHANGES" -gt "0" ]; then
        git commit -m "${CI_COMMIT_TITLE}"
        git push -o ci.skip
      fi    
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop
  allow_failure: true
  rules:
  - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
    when: never
  - if: "$REVIEW_DISABLED"
    when: never
  - if: $CI_MERGE_REQUEST_IID
    when: manual
  - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'
    when: never

license_scanning:
  rules:
  - if: "$LICENSE_MANAGEMENT_DISABLED"
    when: never
  - if: "$CI_MERGE_REQUEST_IID && $GITLAB_FEATURES =~ /\\blicense_scanning\\b/"
  - if: "($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && $GITLAB_FEATURES =~ /\\blicense_scanning\\b/"

dast_environment_deploy:
  environment:
    url: https://dast-$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.$KUBE_INGRESS_BASE_DOMAIN



dast:
  rules:
  - if: "$DAST_DISABLED"
    when: never
  - if: "$DAST_DISABLED_FOR_DEFAULT_BRANCH && $CI_DEFAULT_BRANCH == $CI_COMMIT_REF_NAME"
    when: never
  - if: "$CI_DEFAULT_BRANCH != $CI_COMMIT_REF_NAME && $REVIEW_DISABLED && $DAST_WEBSITE
      == null && $DAST_API_SPECIFICATION == null"
    when: never
  - if: "$CI_MERGE_REQUEST_IID && $CI_KUBERNETES_ACTIVE && $GITLAB_FEATURES =~ /\\bdast\\b/"
  - if: "$CI_MERGE_REQUEST_IID && $GITLAB_FEATURES =~ /\\bdast\\b/ && $DAST_WEBSITE"
  - if: "$CI_MERGE_REQUEST_IID && $GITLAB_FEATURES =~ /\\bdast\\b/ && $DAST_API_SPECIFICATION"
  - if: "($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && $CI_KUBERNETES_ACTIVE && $GITLAB_FEATURES =~ /\\bdast\\b/"
  - if: "($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && $GITLAB_FEATURES =~ /\\bdast\\b/ && $DAST_WEBSITE"
  - if: "($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && $GITLAB_FEATURES =~ /\\bdast\\b/ && $DAST_API_SPECIFICATION"

container_scanning:
  rules:
  - if: "$CONTAINER_SCANNING_DISABLED"
    when: never
  - if: "$CI_MERGE_REQUEST_IID && $GITLAB_FEATURES =~ /\\bcontainer_scanning\\b/"
  - if: "($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && $GITLAB_FEATURES =~ /\\bcontainer_scanning\\b/"


eslint-sast:
  rules:
  - if: "$SAST_DISABLED"
    when: never
  - if: "$SAST_EXCLUDED_ANALYZERS =~ /eslint/"
    when: never
#  - if: "$CI_COMMIT_BRANCH && $SAST_DEFAULT_ANALYZERS =~ /eslint/"
#    exists:
#    - "**/*.html"
#    - "**/*.js"
#    - "**/*.jsx"
#    - "**/*.ts"
#    - "**/*.tsx"
  - if: "$CI_MERGE_REQUEST_IID && $SAST_DEFAULT_ANALYZERS =~ /eslint/"
    exists:
    - "**/*.html"
    - "**/*.js"
    - "**/*.jsx"
    - "**/*.ts"
    - "**/*.tsx"
  - if: $CI_COMMIT_TAG
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

gemnasium-dependency_scanning:
  rules:
  - if: "$DEPENDENCY_SCANNING_DISABLED"
    when: never
  - if: "$DS_EXCLUDED_ANALYZERS =~ /gemnasium([^-]|$)/"
    when: never
  - if: "$CI_MERGE_REQUEST_IID && $GITLAB_FEATURES =~ /\\bdependency_scanning\\b/ && $DS_DEFAULT_ANALYZERS
      =~ /gemnasium([^-]|$)/"
    exists:
    - "{Gemfile.lock,*/Gemfile.lock,*/*/Gemfile.lock}"
    - "{composer.lock,*/composer.lock,*/*/composer.lock}"
    - "{gems.locked,*/gems.locked,*/*/gems.locked}"
    - "{go.sum,*/go.sum,*/*/go.sum}"
    - "{npm-shrinkwrap.json,*/npm-shrinkwrap.json,*/*/npm-shrinkwrap.json}"
    - "{package-lock.json,*/package-lock.json,*/*/package-lock.json}"
    - "{yarn.lock,*/yarn.lock,*/*/yarn.lock}"
    - "{packages.lock.json,*/packages.lock.json,*/*/packages.lock.json}"
    - "{conan.lock,*/conan.lock,*/*/conan.lock}"
  - if: "($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && $GITLAB_FEATURES =~ /\\bdependency_scanning\\b/ && $DS_DEFAULT_ANALYZERS
      =~ /gemnasium([^-]|$)/"
    exists:
    - "{Gemfile.lock,*/Gemfile.lock,*/*/Gemfile.lock}"
    - "{composer.lock,*/composer.lock,*/*/composer.lock}"
    - "{gems.locked,*/gems.locked,*/*/gems.locked}"
    - "{go.sum,*/go.sum,*/*/go.sum}"
    - "{npm-shrinkwrap.json,*/npm-shrinkwrap.json,*/*/npm-shrinkwrap.json}"
    - "{package-lock.json,*/package-lock.json,*/*/package-lock.json}"
    - "{yarn.lock,*/yarn.lock,*/*/yarn.lock}"
    - "{packages.lock.json,*/packages.lock.json,*/*/packages.lock.json}"
    - "{conan.lock,*/conan.lock,*/*/conan.lock}"
  
gosec-sast:
  rules:
  - if: "$SAST_DISABLED"
    when: never
  - if: "$SAST_EXCLUDED_ANALYZERS =~ /gosec/"
    when: never
  - if: "$CI_MERGE_REQUEST_IID && $SAST_DEFAULT_ANALYZERS =~ /gosec/"
    exists:
    - "**/*.go"
  - if: $CI_MERGE_REQUEST_IID
  - if: $CI_COMMIT_TAG
  - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

browser_performance:
  rules:
  - if: $CI_KUBERNETES_ACTIVE == null || $CI_KUBERNETES_ACTIVE == ""
    when: never
  - if: "$BROWSER_PERFORMANCE_DISABLED"
    when: never
  - if: $CI_MERGE_REQUEST_IID
  - if: "$CI_COMMIT_TAG || ($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH)"

secret_detection:
  rules:
  - if: "$SECRET_DETECTION_DISABLED"
    when: never
  - if: "$CI_MERGE_REQUEST_IID && $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH"
